package com.tm1.consdb;
import com.applix.tm1.*;

public class TM1CellValue {
	
	static void GetCellValue(TM1Server oServer)
	/***************************************************************
	Description:
				This method illustrates retrieving a cell value from a cube
	Parameters:
		   		Server object
	Return:
				void
	***************************************************************/
		{
	            TM1Cube oCube;
	            TM1Val elemTitles;
	            TM1Element ele;
	            String elestr;
	            TM1Val ret;

	        //get oCube
			oCube = oServer.getCube ("Cube1");
			if (oCube.isError()){
	                        System.out.println (oCube.getErrorMessage());
			}else{
			    //get elementTitles
			    elemTitles =TM1Val.makeArrayVal (oCube.getDimensionCount().getInt());
			    	//for each oDimension
			    for (int iCTR = 1; iCTR<=oCube.getDimensionCount().getInt(); iCTR++){
			            //for each element in the oDimension
			            for (int iCOUNT = 1; iCOUNT<=oCube.getDimension(iCTR).getElementCount().getInt(); iCOUNT++){
			                //get element handle
			                ele = oCube.getDimension (iCTR).getElement (iCOUNT);

			                //if the element is of type simple
			                if (ele.getElementType() == TM1ObjectType.ElementSimple){
			                    //add the element to the array
			                    elemTitles.addToArray (ele);
			                    elestr = ele.getName().getString();
			                    System.out.println(elestr);
			                    break;
			                    }
			                }
			            }
			    //get the cell value w\these ele titles
			    ret = oCube.getCellValue (elemTitles);
			    if (ret.isError()){
	                        System.out.println (ret.getErrorMessage());
	                    }else{
	                        int type = ret.getType();
	                        switch (type){
	                            case 0:
	                            System.out.println ("Null Value");
	                            break;
	                            case 1:
	                            System.out.println ("Real\\Float Value: " + (new Double (ret.getReal())).toString());
	                            break;
	                            case 2:
	                            System.out.println ("String Value: " + ret.getString().toString());
	                            break;
	                            case 3:
	                            System.out.println ("Int Value: " + (new Integer (ret.getInt())).toString());
	                            break;
	                            case 4:
	                            System.out.println ("Boolean value");
	                            break;
	                            case 5:
	                            System.out.println ("Object value");
	                            break;
	                            case 6:
	                            System.out.println ("Error value");
	                            break;
	                            case 7:
	                            System.out.println ("Array value");
	                            break;
	                            default:
	                            System.out.println ("Default value");
	                            break;
	                            }
	                        }
			    }
		}


		static boolean SetCellValue(TM1Server oServer, String CUBE,double dVAL)
	/***************************************************************
	Description:
				This method illustrates setting a cell value into a cube
	Parameters:
			   	Server object
			   	Cube name
				Value
	Return:
				boolean
	***************************************************************/
			{
		            TM1Cube oCube;
		            TM1Val elemTitles;
		            TM1Element ele;
		            TM1Val ret;

			    //get oCube
				oCube = oServer.getCube (CUBE);
				if (oCube.isError()){
		                        System.out.println (oCube.getErrorMessage());
		                        return (false);
				}else{
				    //make array value
				    elemTitles = TM1Val.makeArrayVal (oCube.getDimensionCount().getInt());

				    //for each oDimension
				    for (int iCTR = 1; iCTR<=oCube.getDimensionCount().getInt(); iCTR++){

				            //for each element in the oDimension
				            for (int iCOUNT = 1; iCOUNT<=oCube.getDimension(iCTR).getElementCount().getInt(); iCOUNT++){
				                //get element handle
				                ele = oCube.getDimension (iCTR).getElement (iCOUNT);

				                //if element is simple
				                if (ele.getElementType() == TM1ObjectType.ElementSimple){

				                    //add to array and go to next oDimension
				                    elemTitles.addToArray (ele);
				                    break;
				                    }
				                }
				            }

				   //set the cell value
				    ret = oCube.setCellValue (elemTitles, new TM1Val (dVAL));
				    if (ret.isError()){
		                       // System.out.println (ret.getErrorMessage());
		                        return (false);
		                    }else{
		                        return (true);}
		                }
		}

		static void GetCellValue2(TM1Server oServer) {
	        TM1Cube oCube;
	        TM1Val elemTitles;
	        TM1Val ret;

	        //get oCube
			oCube = oServer.getCube ("Cube1");
			if (oCube.isError()){
				System.out.println (oCube.getErrorMessage());
			}
			else{
			    //get elementTitles
			    elemTitles =TM1Val.makeArrayVal (oCube.getDimensionCount().getInt());
			    //for each oDimension
			    
			    TM1Dimension account = oCube.getDimension("Accounts");
			    TM1Dimension branch = oCube.getDimension("Branch");
			    TM1Dimension employee = oCube.getDimension("Employee");
			    TM1Dimension jobcodes = oCube.getDimension("JobCodes");
			    TM1Dimension products = oCube.getDimension("Products");
			    TM1Dimension time = oCube.getDimension("Time");
			    
			    TM1Element account_elem = account.getElement("Actual_Units");
			    TM1Element branch_elem = branch.getElement("999999");
			    TM1Element employee_elem = employee.getElement("999999");
			    TM1Element jobcodes_elem = jobcodes.getElement("JobCodes");
			    TM1Element products_elem = products.getElement("Savings Consumer");
			    TM1Element time_elem = time.getElement("2013 - JAN");
			    
			    elemTitles.addToArray (account_elem);
			    	System.out.println(account_elem.getName().getString());
			    elemTitles.addToArray (branch_elem);
			    	System.out.println(branch_elem.getName().getString());
			    elemTitles.addToArray (employee_elem);
			    	System.out.println(employee_elem.getName().getString());
			    elemTitles.addToArray (jobcodes_elem);
			    	System.out.println(jobcodes_elem.getName().getString());
			    elemTitles.addToArray (products_elem);
			    	System.out.println(products_elem.getName().getString());
	    		elemTitles.addToArray (time_elem);
			    	System.out.println(time_elem.getName().getString());
			    
			    ret = oCube.getCellValue (elemTitles);
			    if (ret.isError()){
			    	System.out.println (ret.getErrorMessage());
			    }else{
			    	int type = ret.getType();
			    	switch (type){
			    	case 0:
	                            System.out.println ("Null Value");
	                            break;
	                            case 1:
	                            System.out.println ("Real\\Float Value: " + (new Double (ret.getReal())).toString());
	                            break;
	                            case 2:
	                            System.out.println ("String Value: " + ret.getString().toString());
	                            break;
	                            case 3:
	                            System.out.println ("Int Value: " + (new Integer (ret.getInt())).toString());
	                            break;
	                            case 4:
	                            System.out.println ("Boolean value");
	                            break;
	                            case 5:
	                            System.out.println ("Object value");
	                            break;
	                            case 6:
	                            System.out.println ("Error value");
	                            break;
	                            case 7:
	                            System.out.println ("Array value");
	                            break;
	                            default:
	                            System.out.println ("Default value");
	                            break;
	                            }
	                        }
			    }
			}

		static void GetViewValue(TM1Server oServer) {
			
			TM1Cube oCube;
			TM1View view;
	        TM1Val ret;

	        //get oCube
			oCube = oServer.getCube ("Cube1");
			if (!oCube.isError()){
				
				view = oCube.getView("JavaTest2");
				view.constructArray();

				//Output array number of columns and rows
				System.out.println(view.getNumberOfArrayColumns());
				System.out.println(view.getNumberOfArrayRows());
				System.out.println("");
				
				for (int x = 1; x <= view.getNumberOfArrayColumns(); x++){
					
					for (int y = 1; y <= view.getNumberOfArrayRows(); y++){
					
						//Loop through view array and output values 
						ret = view.getArrayValue(x,y);
						System.out.println("Value of: " + x + " + " + y + " is: " + ret.getInt());
					}
			
				}
										
			}
			else{
				System.out.println (oCube.getErrorMessage());
			}
		}

}
